//-------------------------------------------------------------------------------------------------------
// VST Plug-Ins SDK
// Version 2.4		$Date: 2006/11/13 09:08:27 $
//
// Category     : VST 2.x SDK Samples
// Filename     : again.h
// Created by   : Steinberg Media Technologies
// Description  : Stereo plugin which applies Gain [-oo, 0dB]
//
// modified by NGUYEN.Chung for FB_chungVST (2012)
//-------------------------------------------------------------------------------------------------------

#ifndef __again__
#define __again__

#include "public.sdk/source/vst2.x/audioeffectx.h"

#include <windows.h>
//#include <Winuser.h>
//#include <iostream>
#include <string.h>
//#include <stdio.h>
#include <sstream>


using namespace std;


const string str(double var){ostringstream str;str << var;return str.str();};
void notice(const string text){MessageBox(NULL,text.c_str(),"notice",MB_OK);};



//-------------------------------------------------------------------------------------------------------
class AGain : public AudioEffectX
{
public:
	AGain (audioMasterCallback audioMaster);
	~AGain ();

	// Processing
	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);
	//virtual void processDoubleReplacing (double** inputs, double** outputs, VstInt32 sampleFrames);
    //virtual VstInt32 processEvents(VstEvents* ev);
	// Program
	virtual void setProgramName (char* name);
	virtual void getProgramName (char* name);

	// Parameters
	virtual void setParameter (VstInt32 index, float value);
	virtual float getParameter (VstInt32 index);
	virtual void getParameterLabel (VstInt32 index, char* label);
	virtual void getParameterDisplay (VstInt32 index, char* text);
	virtual void getParameterName (VstInt32 index, char* text);

	virtual bool getEffectName (char* name);
	virtual bool getVendorString (char* text);
	virtual bool getProductString (char* text);
	virtual VstInt32 getVendorVersion ();
	virtual VstInt32 canDo (char* text);

	virtual void resume();
	virtual void nop(){};

protected:
	float fGain;
	char programName[kVstMaxProgNameLen + 1];
};


#endif
